import { Map, OrderedSet } from "immutable";
import { Type } from "./Type";
import { BaseGraphRewriteBuilder } from "./GraphRewriting";
export declare class TypeAttributeKind<T> {
    readonly name: string;
    constructor(name: string);
    combine(_a: T, _b: T): T;
    intersect(a: T, b: T): T;
    makeInferred(_: T): T | undefined;
    children(_: T): OrderedSet<Type>;
    stringify(_: T): string | undefined;
    readonly inIdentity: boolean;
    requiresUniqueIdentity(_: T): boolean;
    reconstitute<TBuilder extends BaseGraphRewriteBuilder>(_builder: TBuilder, a: T): T;
    makeAttributes(value: T): TypeAttributes;
    tryGetInAttributes(a: TypeAttributes): T | undefined;
    private setInAttributes(a, value);
    modifyInAttributes(a: TypeAttributes, modify: (value: T | undefined) => T | undefined): TypeAttributes;
    combineInAttributes(a: TypeAttributes, value: T): TypeAttributes;
    setDefaultInAttributes(a: TypeAttributes, makeDefault: () => T): TypeAttributes;
    removeInAttributes(a: TypeAttributes): TypeAttributes;
    equals(other: any): boolean;
    hashCode(): number;
}
export declare type TypeAttributes = Map<TypeAttributeKind<any>, any>;
export declare const emptyTypeAttributes: TypeAttributes;
export declare type CombinationKind = "union" | "intersect";
export declare function combineTypeAttributes(kind: CombinationKind, attributeArray: TypeAttributes[]): TypeAttributes;
export declare function combineTypeAttributes(kind: CombinationKind, a: TypeAttributes, b: TypeAttributes): TypeAttributes;
export declare function makeTypeAttributesInferred(attr: TypeAttributes): TypeAttributes;
export declare const descriptionTypeAttributeKind: TypeAttributeKind<OrderedSet<string>>;
export declare const propertyDescriptionsTypeAttributeKind: TypeAttributeKind<Map<string, OrderedSet<string>>>;
