"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ci = require("../../cli/ci");
describe("tryHash", function () {
    it("should get undefined if any parameter is", function () {
        var hash = ci.tryHash(["hello", undefined, "world"]);
        expect(hash).toBeUndefined();
    });
    it("should get a string if all parameters are", function () {
        var hash = ci.tryHash(["hello", "world"]);
        expect(typeof hash).toBe("string");
    });
});
describe("getProvider", function () {
    it("should get a provider for Travis", function () {
        var provider = ci.getProvider({
            TRAVIS_REPO_SLUG: "quicktype/quicktype"
        });
        expect(provider && provider.provider).toBe("Travis");
    });
    it("should get undefined provider for empty environment", function () {
        var provider = ci.getProvider({});
        expect(provider).toBeUndefined();
    });
});
